From 1ec272255489628632d4b7f6d36b2e3b07403b4b Mon Sep 17 00:00:00 2001
From: Emil Renner Berthing <emil.renner.berthing@canonical.com>
Date: Sun, 20 Nov 2022 16:35:29 +0100
Subject: [PATCH 40/40] [HACK] riscv: dts: starfive: Add VisionFive 2 reserved
 memory node

Add reserving memory node to the StarFive VisionFive 2 device tree
telling linux to avoid memory used by OpenSBI. This avoids an error when
booting through their U-Boots EFI implementation.

Signed-off-by: Emil Renner Berthing <emil.renner.berthing@canonical.com>
---
 .../dts/starfive/jh7110-starfive-visionfive-2.dtsi   | 12 ++++++++++++
 1 file changed, 12 insertions(+)

diff --git a/arch/riscv/boot/dts/starfive/jh7110-starfive-visionfive-2.dtsi b/arch/riscv/boot/dts/starfive/jh7110-starfive-visionfive-2.dtsi
index fa647117835e..378b2294b17b 100644
--- a/arch/riscv/boot/dts/starfive/jh7110-starfive-visionfive-2.dtsi
+++ b/arch/riscv/boot/dts/starfive/jh7110-starfive-visionfive-2.dtsi
@@ -33,6 +33,18 @@ memory@40000000 {
 		reg = <0x0 0x40000000 0x1 0x0>;
 	};
 
+	reserved-memory {
+		#address-cells = <2>;
+		#size-cells = <2>;
+		ranges;
+
+		/* broken u-boot workaround */
+		opensbi@40000000 {
+			reg = <0x0 0x40000000 0x0 0x200000>;
+			no-map;
+		};
+	};
+
 	gpio-restart {
 		compatible = "gpio-restart";
 		gpios = <&sysgpio 35 GPIO_ACTIVE_HIGH>;
-- 
2.41.0

